/* grlen.f -- translated by f2c (version 20090411).
   You must link the resulting object file with libf2c:
	on Microsoft Windows system, link with libf2c.lib;
	on Linux or Unix systems, link with .../path/to/libf2c.a -lm
	or, if you install libf2c.a in a standard place, with -lf2c -lm
	-- in that order, at the end of the command line, as in
		cc *.o -lf2c -lm
	Source for libf2c is in /netlib/f2c/libf2c.zip, e.g.,

		http://www.netlib.org/f2c/libf2c.zip
*/

#include <math.h>
#include <stdlib.h>
#include "pgplot.h"

/* Table of constant values */

static real c_b3 = .6f;

/* *GRLEN -- inquire plotted length of character string */
/* + */
/* Subroutine */ void grlen_(char *string, real *d__, ftnlen string_len)
{
    /* System generated locals */
    integer i__1, i__2;

    /* Local variables */
    static integer i__;
    static real dx;
    static integer lx;
    static real cosa, sina;
    static integer list[256];
    static real ratio;
    static integer nlist;
    static real fntfac, factor, fntbas;
    static logical unused;
    static integer xygrid[300], ifntlv;

/* GRPCKG: length of text string (absolute units) */
/* -- */
/* (3-Mar-1983) */
/* 19-Jan-1988 - remove unused label [TJP]. */
/*  9-Sep-1989 - standardize [TJP]. */
/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */
/*            Include file for GRPCKG */
/* Modifications: */
/*   29-Jan-1985 - add HP2648 (KS/TJP). */
/*   16-Sep-1985 - remove tabs (TJP). */
/*   30-Dec-1985 - add PS, VPS (TJP). */
/*   27-May-1987 - remove ARGS, NULL, PS, VPS, QMS, VQMS, HIDMP, */
/*                 HP7221, GRINL (TJP). */
/*    6-Jun-1987 - remove PRTX, TRILOG, VERS, VV (TJP). */
/*   11-Jun-1987 - remove remaining built-in devices (TJP). */
/*    5-Jul-1987 - replace GRINIT, GRPLTD by GRSTAT. */
/*   16-Aug-1987 - remove obsolete variables. */
/*    9-Sep-1989 - add SAVE statement. */
/*   26-Nov-1990 - remove GRCTYP. */
/*    5-Jan-1993 - add GRADJU. */
/*    1-Sep-1994 - add GRGCAP. */
/*   21-Dec-1995 - increase GRIMAX to 8. */
/*   30-Apr-1997 - remove GRC{XY}SP */
/* ----------------------------------------------------------------------- */

/* Parameters: */
/*   GRIMAX : maximum number of concurrent devices */
/*   GRFNMX : maximum length of file names */
/*   GRCXSZ : default width of chars (pixels) */
/*   GRCYSZ : default height of chars (pixels) */


/* Common blocks: */
/*   GRCIDE : identifier of current plot */
/*   GRGTYP : device type of current plot */
/* The following are qualified by a plot id: */
/*   GRSTAT : 0 => workstation closed */
/*            1 => workstation open */
/*            2 => picture open */
/*   GRPLTD : */
/*   GRDASH : software dashing in effect? */
/*   GRUNIT : unit associated with id */
/*   GRFNLN : length of filename */
/*   GRTYPE : device type */
/*   GRXMXA : x size of plotting surface */
/*   GRYMXA : y size of plotting surface */
/*   GRXMIN : blc of plotting window */
/*   GRYMIN : ditto */
/*   GRXMAX : trc of plotting window */
/*   GRYMAX : ditto */
/*   GRSTYL : line style (integer code) */
/*   GRWIDT : line width (integer code) */
/*   GRCCOL : current color index (integer code) */
/*   GRMNCI : minimum color index on this device */
/*   GRMXCI : maximum color index on this device */
/*   GRCMRK : marker number */
/*   GRXPRE : previous (current) pen position (x) */
/*   GRYPRE : ditto (y) */
/*   GRXORG : transformation variables (GRTRAN) */
/*   GRYORG : ditto */
/*   GRXSCL : ditto */
/*   GRYSCL : ditto */
/*   GRCSCL : character scaling factor */
/*   GRCFAC : */
/*   GRCFNT : character font */
/*   GRFILE : file name (character) */
/*   GRGCAP : device capabilities (character) */
/*   GRPXPI : pixels per inch in x */
/*   GRPYPI : pixels per inch in y */
/*   GRADJU : TRUE if GRSETS (PGPAP) has been called */


/* ----------------------------------------------------------------------- */

    *d__ = 0.f;
    if (string_len <= 0) {
	return;
    }
/* ----------------------------------------------------------------------- */
/*               Compute scaling and orientation */
/* ----------------------------------------------------------------------- */
    factor = grcm00_.grcfac[grcm00_.grcide - 1] / 2.5f;
    ratio = grcm00_.grpxpi[grcm00_.grcide - 1] / grcm00_.grpypi[
	    grcm00_.grcide - 1];
    cosa = factor;
    sina = 0.f;
    fntbas = 0.f;
    fntfac = 1.f;
    ifntlv = 0;

/*               Convert string to symbol numbers: */
/*               \u and \d escape sequences are converted to -1,-2 */

    grsyds_(list, &nlist, string, &grcm00_.grcfnt[grcm00_.grcide - 1], 
	    string_len);

/*               Plot the string of characters */

    i__1 = nlist;
    for (i__ = 1; i__ <= i__1; ++i__) {
	if (list[i__ - 1] < 0) {
	    if (list[i__ - 1] == -1) {
		++ifntlv;
		fntbas += fntfac * 16.f;
		i__2 = abs(ifntlv);
		fntfac = pow(c_b3, i__2);
	    } else if (list[i__ - 1] == -2) {
		--ifntlv;
		i__2 = abs(ifntlv);
		fntfac = pow(c_b3, i__2);
		fntbas -= fntfac * 16.f;
	    }
	    goto L380;
	}
	grsyxd_(&list[i__ - 1], xygrid, &unused);
	lx = xygrid[4] - xygrid[3];
	dx = cosa * lx * ratio;
	*d__ += dx * fntfac;
L380:
	;
    }
} /* grlen_ */

