#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void main(void) {
  int nc1, nc2, nc3, fsize;
	int index[3000];
	short buffer[27000];
	char line[256];
	char colorname[1000][128];
	int rr[1000], rg[1000], rb[1000];
	int i, j, n;
	
	FILE *fd;

/* start off with grfont.dat */

	fd = fopen("grfont.dat", "rb");
	
/* Apparently, fortran writes the filesize as first 4 bytes */

	fread(&fsize, 4, 1, fd);
	fread(&nc1, 4, 1, fd);
	fread(&nc2, 4, 1, fd);
	fread(&nc3, 4, 1, fd);

  fread(index, 4, 3000, fd);
	fread(buffer, 2, 27000, fd);
	
	fclose(fd);
	
	printf("%i %i %i\n", nc1, nc2, nc3);
	
	i = 0;
/*	printf("      INTEGER INDEX(3000)\n"); */
	printf("      DATA INDEX/\n");
	for (i = 0; i < 300; i++) {
	  printf("     c");
		for (j = 0; j < 10; j++) {
		  if (i == 0 && j == 0) printf(" %5i", index[i*10+j]);
			else printf(",%5i", index[i*10+j]);
		}
		if (i == 299) printf("/\n");
		else printf("\n");
	}
	
	i = 0;
/*	printf("      INTEGER*2 BUFFER(27000)\n"); */
  printf("\n");
	printf("      DATA BUFFER/\n");
	for (i = 0; i < 2700; i++) {
	  printf("     c");
		for (j = 0; j < 10; j++) {
		  if (i == 0 && j == 0) printf(" %5i", buffer[i*10+j]);
			else printf(",%5i", buffer[i*10+j]);
		}
		if (i == 2699) printf("/\n");
		else printf("\n");
	}
	
	printf("      NC1 = %i\n", nc1);
	printf("      NC2 = %i\n", nc2);

/* now rgb.txt */
  fd = fopen("rgb.txt", "rb");
	
	n = 0;
	while (fgets(line, 256, fd) != NULL) {
	  if (sscanf(line, "%i %i %i", &rr[n], &rg[n], &rb[n])) {
		  for (i = 12, j = 0; i < strlen(line); i++, j++) colorname[n][j] = toupper(line[i]);
			if (j > 0) colorname[n][j-1] = '\0';
			if (j > 20) colorname[n][20] = '\0';
		}
		n++;
	}
	fclose(fd);
	
	
	for (i = 0; i < n; i++) {
	  printf("          RR(%i) = %i/255.0\n", i+1, rr[i]);
	  printf("          RG(%i) = %i/255.0\n", i+1, rg[i]);
	  printf("          RB(%i) = %i/255.0\n", i+1, rb[i]);
		printf("          CNAME(%i) = '%s'\n", i+1, colorname[i]);
	}
	printf("          NCOL = %i\n", n);
}
